## v1: Victor FARDEL, Michele Nasoni: mars 2017

## Permets d'executer des script SAS sans avoir à lancer l'interface SAS linux
## L'interface Kate essaie de reproduire l'interface SAS windows.
## Les éléments de sorties sont générés

#!/bin/bash

### Vérification des arguments: un fichier avec l'extension .sas est attendu
export NOBROWSER=1
if [ $# -ne 1 ]; then
	echo "=== ====================================================== ==="
	echo "=== ====================================================== ==="
	echo "=== Veuillez spécifier le nom d'un fichier .sas à exécuter ==="
	echo "=== ====================================================== ==="
	echo "=== ====================================================== ==="
	exit
fi


_DIRNAME=`dirname "$1"`
### Vérification du chemin d'accès fourni
if [ ! -d  "$_DIRNAME" ]; then
        echo "=== ===================================== ==="
        echo "=== ===================================== ==="
        echo "=== Le chemin d'accès comporte une erreur ==="
        echo "=== ===================================== ==="
        echo "=== ===================================== ==="
exit
fi

### Vérification de la synthaxe
FILEN=$1


/usr/local/stat/bin/sas $FILEN 


if [ $? -ne 0 ]; then

	cat ${FILEN%%.*}.log | iconv -f iso-8859-1 -t utf8 
	
	# Le code contient une erreur, nous affichons le message à la fin de la sortie #
echo "==== ============================== ====" 
echo "==== ============================== ====" 
echo "==== Votre code contient une erreur ====" 
echo "==== ============================== ====" 
echo "==== ============================== ====" 
	
	exit

fi

### Production des sorties: .log et .lst
echo "==== ================== ====" 
echo "==== ================== ====" 
echo "==== Début de le sortie ====" 
echo "==== ================== ====" 
echo "==== ================== ====" 

	# Affichage du journal d'exécution #
echo "==== ================================================ ====" 
echo "==== ================================================ ====" 
echo "==== SAS Journal: rapport de l'exécution du programme ====" 
echo "==== ================================================ ====" 
echo "==== ================================================ ====" 

cat ${FILEN%%.*}.log | iconv -f iso-8859-1 -t utf8

#echo "==== ======================================= ====" 
#echo "==== ======================================= ====" 
#echo "==== SAS Journal: fin du rapport d'exécution ====" 
#echo "==== ======================================= ====" 
#echo "==== ======================================= ===="

# Comments
	# Affichage des résultats de l'exécution #
echo "==== ================================================== ====" 
echo "==== ================================================== ====" 
echo "==== SAS Output: le résultat des différentes procédures ====" 
echo "==== ================================================== ====" 
echo "==== ================================================== ====" 

cat ${FILEN%%.*}.lst | iconv -f iso-8859-1 -t utf8

#echo "==== ============================= ====" 
#echo "==== ============================= ====" 
#echo "==== SAS Output: fin des résultats ====" 
#echo "==== ============================= ====" 
#echo "==== ============================= ===="
